/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: Maven2ResourceFetcherFactory.java 4392 2008-12-15 14:05:41Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.plan.fetcher.impl.maven2;

import org.ow2.util.plan.bindings.deploymentplan.DeploymentPlanFragment;
import org.ow2.util.plan.bindings.deploymentplan.maven2.Maven2Deployment;
import org.ow2.util.plan.fetcher.api.IResourceFetcher;
import org.ow2.util.plan.fetcher.api.IResourceFetcherFactory;
import org.ow2.util.plan.fetcher.api.exceptions.FetcherFactoryException;
import org.ow2.util.plan.fetcher.impl.AbsResourceFetcherFactoryImpl;

/**
 * Factory for the Maven2 implementation of the resource fetcher.
 * @author Mickaël LEDUQUE
 */
public class Maven2ResourceFetcherFactory extends AbsResourceFetcherFactoryImpl implements IResourceFetcherFactory {

    /**
     * Default constructor.
     */
    public Maven2ResourceFetcherFactory() {
        this.setFetcherConcreteClass(Maven2ResourceFetcher.class);
    }

    /**
     * {@inheritDoc}
     */
    public Class<? extends DeploymentPlanFragment> getSupportedClass() {
        return Maven2Deployment.class;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public IResourceFetcher getResourceFetcher(final DeploymentPlanFragment fragment) throws FetcherFactoryException {
        Maven2ResourceFetcher fetcher = (Maven2ResourceFetcher)super.getResourceFetcher(fragment);
        return fetcher;
    }
}
